<template>
  <b-overlay :show="overlayAccess" rounded="sm" variant="primary" spinner-type="" opacity="0.1" blur="2px">
    <b-overlay :show="overlay" rounded="sm" variant="primary" opacity="0.4" blur="2px">
      <ValidationObserver v-slot="{ invalid }">
        <div class="card-body">
          <div class="col-12 mb-20">
            <div v-for="(object,index) in education" v-bind:key="index">
              <b-row class="form-group mb-0">
                <b-col md="4">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      رشته تحصیلی
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <ValidationProvider rules="required" v-slot="{ errors }">
                        <input
                            type="text"
                            class="form-control"
                            v-model="object.major"
                            placeholder="مثال: مهندسی کامپیوتر گرایش فناوری و اطلاعات"
                            name="رشته تحصیلی"
                        />
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </div>
                  </div>
                </b-col>
                <b-col md="4">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      محل تحصیل
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <ValidationProvider rules="required" v-slot="{ errors }">
                        <input
                            type="text"
                            class="form-control"
                            v-model="object.location"
                            placeholder="مثال: دانشگاه صنعتی شیراز"
                            name="محل تحصیل"
                        />
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </div>
                  </div>
                </b-col>
                <b-col md="4">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      مقطع تحصیلی
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <ValidationProvider rules="required" v-slot="{ errors }">
                        <select class="form-control" v-model="object.grade" name="مقطع تحصیلی">
                          <option :value="{name:'دیپلم',value:'diplom'}">دیپلم</option>
                          <option :value="{name:'کاردانی',value:'kardani'}">کاردانی</option>
                          <option :value="{name:'کارشناسی',value:'karshenasi'}">کارشناسی</option>
                          <option
                              :value="{name:'کارشناسی ارشد',value:'karshenasiarshad'}"
                          >کارشناسی ارشد
                          </option>
                          <option :value="{name:'دکترا و بالاتر',value:'doktora'}">دکترا و بالاتر</option>
                        </select>
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </div>
                  </div>
                </b-col>

                <b-col md="4">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      وضعیت
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <ValidationProvider rules="required" v-slot="{ errors }">
                        <select class="form-control" v-model="object.currentStudying">
                          <option :value="true">در حال تحصیل</option>
                          <option :value="false">تمام شده</option>
                        </select>
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </div>
                  </div>
                </b-col>
                <b-col md="4">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      تاریخ شروع تحصیل
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <date-picker
                          v-if="DatePickerShow"
                          v-model="object.startDate"
                          :auto-submit="true"
                          format="YYYY-MM-DD HH:mm:ss"
                          display-format="dddd jDD jMMMM jYYYY"
                          placeholder="مثلا : 1376/04/19"
                      />
                    </div>
                  </div>
                </b-col>
                <b-col md="4">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      تاریخ پایان تحصیل
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <date-picker
                          :disabled="endDateStatus(index)"
                          v-if="DatePickerShow"
                          v-model="object.endDate"
                          :auto-submit="true"
                          format="YYYY-MM-DD HH:mm:ss"
                          display-format="dddd jDD jMMMM jYYYY"
                          placeholder="مثلا : 1376/04/19"
                      />
                    </div>
                  </div>
                </b-col>
                <b-col md="12">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">توضیحات</label>
                    <div class="custom-file">
                      <input
                          type="text"
                          class="form-control"
                          placeholder="توضیح مختصر در مورد این مدرک تحصیلی"
                          v-model="object.description"
                          name="توضیحات"
                      />
                    </div>
                  </div>
                </b-col>
                <b-col md="12" class="mt-2" v-if="index>0">
                  <b-button class="col-12 btn btn-danger" @click="deleteEducation(index)">حذف این مدرک</b-button>
                </b-col>
              </b-row>
              <div class="separator separator-solid separator-border-2 separator-success my-8"></div>
            </div>
            <button type="button" class="btn btn-primary col-3" @click="addEducation">
              افزودن مدرک تحصیلی
              <i class="flaticon2-plus"></i>
            </button>
          </div>
          <div class="col-12 mb-20">
            <div class="col-md-12 mx-auto my-10">
              <div class="alert alert-custom alert-notice alert-light-info fade show" role="alert">
                <div class="alert-icon">
                  <i class="flaticon-medal"></i>
                </div>
                <div class="alert-text text-black-50 mx-4">
                  <b>دوره ها |</b> شما می توانید دوره ها و سمینارهای مرتبط با موضوعات فراخوان ما را که قبلا شرکت نموده
                  اید با استفاده از گزینه ی "افزودن دوره" برای ما ثبت نمایید.
                </div>
              </div>
            </div>
            <div v-for="(object,index) in certifications" v-bind:key="index">
              <b-row class="form-group mb-0">
                <b-col md="3">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      نام دوره
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <ValidationProvider rules="required" v-slot="{ errors }">
                        <input
                            type="text"
                            class="form-control"
                            v-model="object.name"
                            placeholder="مثال: مدرک ICDL"
                            name="نام دوره"
                        />
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </div>
                  </div>
                </b-col>
                <b-col md="3">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      محل اخذ دوره
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <ValidationProvider rules="required" v-slot="{ errors }">
                        <input
                            type="text"
                            class="form-control"
                            v-model="object.location"
                            placeholder="مثال: آموزشگاه سپهر"
                            name="محل اخذ دوره"
                        />
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </div>
                  </div>
                </b-col>
                <b-col md="3">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">توضیحات</label>
                    <div class="custom-file">
                      <ValidationProvider rules="required" v-slot="{ errors }">
                        <input
                            type="text"
                            class="form-control"
                            placeholder="توضیح مختصر در مورد دوره"
                            v-model="object.description"
                            name="توضیحات"
                        />
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </div>
                  </div>
                </b-col>
                <b-col md="3">
                  <label class="col-form-label text-lg-right text-left">حذف دوره</label>
                  <b-button
                      class="col-12 btn btn-danger"
                      @click="deleteCertification(index)"
                  >حذف این دوره
                  </b-button>
                </b-col>
              </b-row>
              <div class="separator separator-solid separator-border-2 separator-success my-8"></div>
            </div>
          </div>

          <button type="button" class="btn btn-primary col-3" @click="addCertification">
            افزودن دوره
            <i class="flaticon2-plus"></i>
          </button>
          <div class="col-md-12 mt-20">
            <div class="d-flex flex-column text-md-center">
        <span id="disabled-wrapper" tabindex="-5">
          <button
              v-if="invalid || overlayAccess"
              type="button"
              :disabled="true"
              class="btn btn-success btn-lg btn-block"
          >ذخیره اطلاعات</button>
          <button
              v-else
              @click="SaveCertifications()"
              type="button"
              class="btn btn-success btn-lg btn-block"
          >ذخیره اطلاعات</button>
        </span>
              <b-tooltip
                  v-if="invalid"
                  class="font-family: IRANYekan !important"
                  target="disabled-wrapper"
              >تا زمانی که همه ی فیلد ها تکمیل نشوند این دکمه فعال نمی شود
              </b-tooltip>
            </div>
          </div>
        </div>
      </ValidationObserver>
    </b-overlay>
  </b-overlay>
</template>

<script>
import {ValidationObserver, ValidationProvider} from "vee-validate";
import gql from "graphql-tag";
import certAndEduInformation from "~/apollo/mutation/resume/certAndEduInformation.gql";

export default {
  props: ['option'],
  name: "certification",
  components: {
    DatePicker: () => import("vue-persian-datetime-picker"),
    ValidationObserver,
    ValidationProvider,
  },
  data() {
    return {
      education: [
        {
          major: "",
          location: "",
          grade: "",
          description: "",
          startDate: "",
          endDate: "",
          currentStudying: true,
        },
      ],
      certifications: [],
      DatePickerShow: false,
      overlay: false,
      overlayAccess: false,
    };
  },

  async mounted() {
     if (this.option){
       if (this.option.ConfirmationStatus!=="Filling"){
         this.overlayAccess=true;
       }
       if (this.option.certifications) {
         this.certifications = this.option.certifications;
       }
       if (this.option.education) {
         this.option.education.map((item) => (
             // eslint-disable-next-line no-param-reassign
             delete item.grade.__typename
         ))
         this.education = this.option.education;
       }
     }
    this.DatePickerShow = true;
  },

  methods: {
    addEducation() {
      let myObject = {
        major: "",
        location: "",
        grade: "",
        description: "",
        startDate: "",
        endDate: "",
        currentStudying: true,
      };
      this.education.push(myObject);
    },
    addCertification() {
      let myObject = {
        name: "",
        location: "",
        description: "",
      };
      this.certifications.push(myObject);
    },
    deleteEducation(index) {
      Swal.fire({
        title: "حذف مدرک تحصیلی",
        text: "آیا از حذف این مورد اطمینان دارید؟",
        icon: "warning",
        confirmButtonText: "باشه",
        cancelButtonText: "انصراف",
        showCancelButton: true,
      }).then((res) => {
        res.isConfirmed ? this.education.splice(index, 1) : "";
      });
    },
    deleteCertification(index) {
      Swal.fire({
        title: "حذف دوره",
        text: "آیا از حذف این مورد اطمینان دارید؟",
        icon: "warning",
        confirmButtonText: "باشه",
        cancelButtonText: "انصراف",
        showCancelButton: true,
      }).then((res) => {
        res.isConfirmed ? this.certifications.splice(index, 1) : "";
      });
    },
    endDateStatus(index) {
      return this.education[index].currentStudying;
    },
    async SaveCertifications() {
      this.overlay = true;
      let self = this;
      let variables = {
        id: this.option.id,
        certifications: JSON.stringify(self.certifications),
        education: JSON.stringify(self.education),
      };
      let mutation = gql`
        ${certAndEduInformation}
      `;
      await this.$apollo
          .mutate({
            mutation,
            variables,
            context: {headers: {"x-token": this.$auth.getToken("local")}},
          })
          .then(({data}) => {
            this.overlay = false;
            Swal.close();
            Swal.fire({
              title: "موفقیت آمیز",
              text: "اطلاعات با موفقیت ثبت شد.",
              icon: "success",
              confirmButtonText: "باشه",
            }).then((res) => {
              this.$emit("my-event", {
                step: "certification",
                education: this.education,
                certifications: this.certifications
              });
            });
          })
          .catch((err) => {
            this.overlay = false;
            Swal.close();
            let gqlError = err.graphQLErrors;
            if (gqlError.length > 0) {
              if (err.graphQLErrors[0].extensions.code == "UNAUTHENTICATED") {
                let self = this;
                console.log("please login");
                /* this.$auth.logout().then(res => {
                     self.$router.push("/login");
                   });*/
              }
            } else {
              Swal.fire({
                title: "خطا",
                text:
                    "مشکل در ارتباط، لطفا اتصال اینترنت خود را بررسی و سپس مجددا تلاش کنید",
                icon: "error",
                confirmButtonText: "باشه",
              });
            }
          });
    },
  },
  computed: {},
};
</script>
<style scoped>
</style>